<id>
Reverse Post Order
</id>

<version>
beta 1.4
</version>

<mod info>
This mod allows a user to select if posts are displayed from oldest to newest (defualt) or newest to oldest in their profile preferences (Global Announcements are excluded from this).  No thread files are manipulated, just how a single individual views it.  

This is a spin off of a mod for 1.3.

Installation
---------------------
1.  Mod the files
2.  Upload the modded files and the language file to the correct directories

Version History
----------------------
ver 1.0 Initial Release
ver 1.1 Fixed Numbering Problem that recieved when trying to modify or quote etc...
ver 1.2 Fixed numerous issues to make the mod work corretly
ver 1.3 Fixed the most recent post issue and basically reworked the numebr of posts
ver 1.4 Added code so that the user will be redirected to a correctly reversed thread after posting if the thread is being watched aand will notify other users of the posting.
</mod info>

<author>
astro-pilot
</author>

<homepage>

</homepage>

<edit file>
Sources/Display.pl
</edit file>

<search for>
			fopen(MNUM, "$datadir/$mnum.txt");

			foreach $mess (<MNUM>) {
				@tmp = split(/\|/, $mess);
				if ($tmp[3] > $dlp) { last; }
				$i++;
			}
			fclose(MNUM);
</search for>

<replace>
			### Reverse Post Order mod ###
			fopen(MSGTXT,"$datadir/$mnum.txt") || &fatal_error("104 $display_txt{'106'}: $display_txt{'23'} $mnum.txt", 1);
			@msgtxt = <MSGTXT>;
			fclose(MSGTXT);
			foreach $mess ( @msgtxt ) {
				@tmp = split(/\|/, $mess);
				if ( $tmp[3] > $dlp) {last;}
				$i++;
			} 
			if (${$uid.$username}{'reverse_posts'} eq "on" && $threadclass ne 'announcement') {$i = ($#msgtxt - $i);}
			### Reverse Post Order mod end ###
</replace>

<search for>
			if ($currentboard eq $annboard) {
				$yySetLocation = qq~$scripturl?virboard=$INFO{'virboard'};num=$mnum/$i#$i~;
			} else {
				$yySetLocation = qq~$scripturl?num=$mnum/$i#$i~;
			}
			&redirectexit;
		}
	}
</search for>

<add after>
	### Reverse Post Order mod ###
	if(${$uid.$username}{'reverse_posts'} eq "on" && $threadclass ne 'announcement' && !$INFO{'revpost'}){
		fopen(MSGTXT,"$datadir/$INFO{'num'}.txt") || &fatal_error("104 $display_txt{'106'}: $display_txt{'23'} $viewnum.txt", 1);
		@msgtxt = <MSGTXT>;
		fclose(MSGTXT);
		$yymain .= qq~
		<script language="JavaScript1.2" type="text/javascript">
			<!-- Begin
				var mnum = $INFO{'num'};
				var postnum = location.hash;
				var address = "$scripturl?num=";
				var start = $INFO{'start'};
				postnum = postnum.replace("#","");
				if(postnum >= $#msgtxt){start = 0; postnum = $#msgtxt;}
				else{postnum = $#msgtxt - postnum;}
				location.replace(address+mnum+"\;revpost=yes;start="+start+"#"+postnum);
			//-->
		</script>~;}
	### Reverse Post Order mod end ###

</add after>

<search for>
	# Skip past the posts in this thread until we reach $start.
	while ($counter < $start && ($buffer = <MSGTXT>)) { $counter++; }

	$#messages = $maxmessagedisplay - 1;
	for ($counter = 0; $counter < $maxmessagedisplay && ($buffer = <MSGTXT>); $counter++) {
		$messages[$counter] = $buffer;
	}
	fclose(MSGTXT);
	$#messages = $counter - 1;
	$counter   = $start;
</search for>

<replace>
	### Reverse Post Order mod ###
	@msgtxt = <MSGTXT>;
	fclose(MSGTXT);
	if (${$uid.$username}{'reverse_posts'} eq "on" && $threadclass ne 'announcement') { @msgtxt = reverse(@msgtxt); }
	for($counter = $start; ($counter < $maxmessagedisplay + $start) && ($counter <= $#msgtxt); $counter++) {
		push (@messages, $msgtxt[$counter]);}
	$counter = $start;

	if (${$uid.$username}{'reverse_posts'} eq "on" && $threadclass ne 'announcement') {$counter = $#msgtxt - $start;}
	### Reverse Post Order end ###
</replace>

<search for>
		$counter++;
	}
</search for>

<replace>
		### Reverse Post Order ###
		if (${$uid.$username}{'reverse_posts'} eq "on" && $threadclass ne 'announcement') {$counter--;}
		else {$counter++;}
		### Reverse Post Order end ###		
	}
</replace>

<search for>
		for (var i = $start; i < $counter; i++) {
			var z = i - $start;
	 		if(i == counter) document.multidel.elements[z].checked = true;
			else document.multidel.elements[z].checked = false;
		}
</search for>

<replace>
		//### Reverse Post Order ###
		var revers = "${$uid.$username}{'reverse_posts'}";
		if (revers == 'on'){
			var z = 0; 
			for (var i = $#msgtxt - $start; z < $maxmessagedisplay; i--) {
	 			if(i == counter) {document.multidel.elements[z].checked = true;}
				else {document.multidel.elements[z].checked = false;}
				z++;
			}
		}
		else {	
			for (var i = $start; i < $counter; i++) {
				var z = i - $start;
	 			if(i == counter) {document.multidel.elements[z].checked = true;}
				else {document.multidel.elements[z].checked = false;}
			}		
		}
		//### Reverse Post Order ###
</replace>

<edit file>
Sources/ModifyMessage.pl
</edit file>

<search for>
	}

	$yySetLocation = qq~$scripturl?num=$threadid/$start#$postid~;
</search for>

<add after>
	if (${$uid.$username}{'reverse_posts'} eq "on" && $threadclass ne 'announcement') {$yySetLocation = qq~$scripturl?num=$threadid#$postid~;}  ### Reverse Post Order ###
</add after>

<edit file>
Admin/Modlist.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$reverse_post_order_mod = "Reverse Post Order beta 1.4_YaBB2|astro-pilot|This mod allows a user to select if posts are displayed from oldest to newest (defualt) or newest to oldest in their profile preferences.  No thread files are manipulated, just how a single individual views it.  |1.4|12/20/05";
	push (@installed_mods, "$reverse_post_order_mod");
</add before>

<edit file>
Sources/Post.pl
</edit file>

<search for>
	if ($currentboard eq $annboard) {
		$yySetLocation = qq~$scripturl?virboard=$currentboard;num=$thread/$start#$mreplies~;
	} else {
		$yySetLocation = qq~$scripturl?num=$thread/$start#$mreplies~;
	}
</search for>

<add after>
	### Reverse Post Order ###	
	if (${$uid.$username}{'reverse_posts'} eq "on" && $threadclass ne 'announcement') {
		if($currentboard eq $annboard) {
			$yySetLocation = qq~$scripturl?virboard=$currentboard;num=$thread~;
		}
		else {
			$yySetLocation = qq~$scripturl?num=$thread~;
		}	
	}
	### Reverse Post Order end ###	
</add after>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
	$yymain .= qq~<tr class="windowbg">
          <td width="320" align="left"><b>$profile_txt{'817'}</b></td>
</search for>

<add before>
	### Reverse Posts Order mod ###
	LoadLanguage("Reverse_Post_Order");
	if (${$uid.$username}{'reverse_posts'} eq "on") {$reverse_posts = 'checked';}
       	$yymain .= qq~ 
       	<tr class="windowbg">
        		<td width="320" align="left"><b>$rpo_txt{'1'}:</b><br />
	          	<span class="small">$rpo_txt{'2'}</span></td>
          		<td align="left"><input type="checkbox" name="reverse_posts" $reverse_posts /></td>
	</tr>~;	
	### Reverse Posts Order end ###

</add before>

<search for>
		${$uid.$user}{'timeformat'}    = "$member{'timeformat'}";
</search for>

<add after>
		${$uid.$user}{'reverse_posts'} = "$member{'reverse_posts'}"; ### Reverse Post Order mod ###
</add after>

<edit file>
Sources/System.pl
</edit file>

<search for>
	my @tags = qw(password realname email regdate webtitle weburl signature postcount position addgroups icq aim yim gender usertext userpic regtime location bday timeselect timeoffset timeformat hidemail msn gtalk template language lastonline lastpost lastim im_ignorelist im_notify im_popup im_imspop cathide postlayout session sesquest sesanswer favorites dsttimeoffset pageindex);
</search for>

<add after>
	push(@tags,reverse_posts); ### Reverse Post Order mod ###
</add after>

<edit file>
Sources/Notify.pl
</edit file>

<search for>
	&ManageThreadNotify("add", $thread, $username, ${$uid.$username}{'language'}, "1", "1");
	$yySetLocation = qq~$scripturl?num=$thread/$start~;
</search for>

<add after>
	### Reverse Post Order ###	
	if (${$uid.$username}{'reverse_posts'} eq "on" && $threadclass ne 'announcement') {
		if($currentboard eq $annboard) {
			$yySetLocation = qq~$scripturl?virboard=$currentboard;num=$thread~;
		}
		else {
			$yySetLocation = qq~$scripturl?num=$thread~;
		}	
	}
	### Reverse Post Order end ###
</add after>

<search for>
	if (-e "$datadir/$thread.mail") {
		&ManageThreadNotify("delete", $thread, $username);
	}
	$yySetLocation = qq~$scripturl?num=$thread/$start~;
</search for>

<add after>
	### Reverse Post Order ###	
	if (${$uid.$username}{'reverse_posts'} eq "on" && $threadclass ne 'announcement') {
		if($currentboard eq $annboard) {
			$yySetLocation = qq~$scripturl?virboard=$currentboard;num=$thread~;
		}
		else {
			$yySetLocation = qq~$scripturl?num=$thread~;
		}	
	}
	### Reverse Post Order end ###
</add after>